;	PCap version 1.00 Copyright (C) 2007 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.

;	To compile download masm32 from http://www.masm32.com and install it on the root directory of one of your hard drives
;	Copy source files to the partition where is masm32 installed and run \masm32\bin\blddll PCap
;	For more information send and e-mail to cristian.albu@gmail.com

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib

	include	plprocs.h
	include	seh.h
tmpnick	struc
	db	40 dup(?)
tmpnick	ends

	dlgConfig	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
	pcThread	PROTO	:DWORD

syn_info	struc
	lastcount	dd	?
	lastip		dd	?
	lastdstip	dd	?
	lastport	dd	?
	isflood		dw	?
	chksum		dw	?
syn_info	ends

syn_str	struc
	syn_idx		db	?
	isflood		db	?
	lastip		dd	?
	sinfo		syn_info 	20 dup(<>)
syn_str	ends

pcap_if_t	struc
	_next	dd	?
	_name	dd	?
	_descr	dd	?
	_addrs	dd	?
	_flags	dd	?
		db	100 dup(?)
pcap_if_t	ends
PCAP_ERRBUF_SIZE=256

.data?
	hInstance	dd	?
	commands	dd	?
	bread		dd	?
	thrid		dd	?
	GetFunctions	dd	?
	SendNotificationMessage dd ?
	NickFromId	dd	?
	IdFromNick	dd	?
	GetIPString	dd	?
	lvit		LV_ITEM	<>
	lvcol		LV_COLUMN <>
	lrect		RECT	<>
	systime		SYSTEMTIME <>
	datafile	db	8192 dup(?)
	opmsgs		db	8192 dup(?)

	pcapfl			dw	?	;0=enabled,1=adapters detected
	pcapadapt		dw	?	;adapter flags
	pcaptimer		dd	?	;timer
	pcapsyn			db	?
	pcapudp			db	?
	pcapicmp		db	?
	firewall		db	?
	fsyn1			dw	?
	fsyn2			dw	?
	pcapadaptors		dd	32 dup(?)	;16+(32*8)+(16*4)+3
	pcapmacs		dd	32 dup(?)
	pcapips			dd	16 dup(?)
	_reserved		db	3 dup(?)

	fsynflood	syn_str	<>
	fudpflood	syn_str	<>
	ficmpflood	syn_str	<>
	fltsyn		dd	?
	fltban		dd	?
	fltport		dd	?
	fpchklast	dd	?
	fltsum		dd	?
	ffinflood	syn_str	<>
	fltfin		dd	?

	hPcap			dd	?
	hIphlp			dd	?
	captate			dd	?
	GetAdaptersInfo		dd	?
	pcap_findalldevs_ex	dd	?
	pcap_freealldevs	dd	?
	pcap_open_live		dd	?
	pcap_next_ex		dd	?
	pcap_close		dd	?
	pchklast		dd	?
	lastsyslog		dd	?
	hSysLog			dd	?
	slogdata		db	512 dup(?)
	slogdataex		db	2560 dup(?)
	slogidx			db	?
	pcapdevs		pcap_if_t <>
	pcaperr			db	PCAP_ERRBUF_SIZE dup(?)

	buftmp		db	65536*2 dup(?)
	buftmp1		db	65536 dup(?)
	buftmp2		db	65536 dup(?)

.code
pluginName	db	'WinPCap extensions',0
fn03		db	'NickFromId',0
fn04		db	'IdFromNick',0
fn05		db	'GetIPString',0
fn11		db	'SendNotificationMessage',0
wpcap		db	'wpcap.dll',0
ipcap		db	'iphlpapi.dll',0
ip_f1		db	'GetAdaptersInfo',0
pcap_f1		db	'pcap_findalldevs_ex',0
pcap_f2		db	'pcap_freealldevs',0
pcap_f3		db	'pcap_open_live',0
pcap_f4		db	'pcap_next_ex',0
pcap_f5		db	'pcap_close',0
pcapstr		db	'rpcap://',0
pcol1		db	'Adapter',0
pcol2		db	'MAC address',0
pcol3		db	'Description',0
pcapmsg		db	'For this to work, you need to download and install WinPcap ( http://www.winpcap.org ).',0


	invoke	InitCommonControls
	pl_procs

DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
	.elseif reason==DLL_PROCESS_DETACH
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp


InitPlugin	PROC	GetAddr:DWORD
	push	edi
	lea	edi,pcapfl
	mov	ecx,16+(32*8)+(16*4)+3
	mov	al,0
	cld
	rep	stosb
	mov	fsyn1,50
	mov	fsyn2,50
	mov	fltsum,0
	.if (pcapsyn==0)&&(pcapudp==0)&&(pcapicmp==0)
		mov	pcapsyn,15
		mov	pcapudp,20
		mov	pcapicmp,15
		or	pcapfl,1f0h
		or	firewall,0c4h
	.endif
	call	getdatafile
	invoke	CreateFile,addr datafile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		invoke	ReadFile,edi,addr pcapfl,16+(32*8)+(16*4)+3,addr bread,0
		call	CloseHandle
	.endif
	pop	edi
	push	GetAddr
	pop	GetFunctions
	push	offset fn03
	call	GetFunctions
	mov	NickFromId,eax
	push	offset fn04
	call	GetFunctions
	mov	IdFromNick,eax
	push	offset fn11
	call	GetFunctions
	mov	SendNotificationMessage,eax
	push	offset fn05
	call	GetFunctions
	mov	GetIPString,eax
	.if pcapfl&4
		call	pcap_init
	.endif

	.if pcapfl&1
		.if (!(pcapfl&2))
			mov	pcaptimer,0
		.endif
		mov	captate,0
		lea	edi,pcapadaptors
		mov	ecx,32
		xor	eax,eax
		cld
		rep	stosd
		invoke	GlobalAlloc,GPTR,65536
		mov	edi,eax
		push	eax
		mov	eax,offset pcapdevs._flags
		mov	dword ptr[eax],65536
		push	eax
		push	edi
		call	GetAdaptersInfo
		.if eax==ERROR_SUCCESS
			mov	esi,edi
			.while esi!=0
				lea	edi,[esi+8]
				push	esi
				mov	esi,pcapdevs._next
				assume	esi:ptr pcap_if_t
				xor	ecx,ecx
				assume	edx:nothing
				.while (esi!=0)
					mov	edx,[esi]._name
					mov	eax,dword ptr[edx]
					or	eax,20202020h
					.if eax=='acpr'
						.if ((byte ptr[edx+4]=='p')||(byte ptr[edx+4]=='P'))&&(word ptr[edx+5]=='/:')&&(byte ptr[edx+7]=='/')
							lea	edx,[edx+8]
						.endif
					.endif
					.if byte ptr[edx]=='\'
						inc	edx
					.endif
					mov	eax,[edx]
					or	eax,20202020h
					.if eax=='ived'
						mov	ax,[edx+4]
						or	ax,2020h
						.if ax=='ec'
							lea	edx,[edx+6]
						.endif
					.endif
					.if byte ptr[edx]=='\'
						inc	edx
					.endif
					mov	ax,[edx]
					or	ax,2020h
					.if ax=='pn'
						.if (byte ptr[edx+2]=='f')||(byte ptr[edx+2]=='F')
							lea	edx,[edx+3]
						.endif
						.if byte ptr[edx]=='_'
							inc	edx
						.endif
					.endif
					mov	esi,[esi]._next
					push	ecx
					xor	ecx,ecx
					.while (byte ptr[edi+ecx]!=0)&&(byte ptr[edi+ecx]!=32)
						mov	al,[edi+ecx]
						mov	ah,[edx+ecx]
						or	ax,2020h
						.break .if al!=ah
						inc	ecx
					.endw
					.if (al==ah)&&(byte ptr[edi+ecx]==0)&&(byte ptr[edx+ecx]==0)
						pop	ecx
						push	ecx
						mov	eax,[edi+256+4+128+4+4]
						mov	pcapmacs[ecx*8],eax
						mov	eax,[edi+256+4+128+4+4+4]
						mov	pcapmacs[ecx*8+4],eax
						push	ebx
						lea	ebx,[edi+256+4+128+4+4+4+4+4+4+4+4+4]
						push	ecx
						call	is_ip
						mov	eax,ecx
						pop	ecx
						mov	pcapips[ecx*4],eax
						pop	ebx
					.endif
					pop	ecx
					inc	ecx
					.break .if ecx>=16
				.endw
				assume	esi:nothing
				pop	esi
				mov	esi,[esi]
			.endw
		.endif
		call	GlobalFree
		mov	esi,pcapdevs._next
		assume	esi:ptr pcap_if_t
		xor	ecx,ecx
		.while esi!=0
			mov	eax,1
			.if ecx
				shl	eax,cl
			.endif
			.if (!(pcapfl&2))
				or	pcapadapt,ax
			.endif
			mov	dword ptr pcapadaptors[ecx*8],0
			mov	dword ptr pcapadaptors[ecx*8+4],0
			push	ecx
			invoke	CreateThread,0,0,addr pcThread,ecx,0,addr thrid
			pop	ecx
			mov	dword ptr pcapadaptors[ecx*8+4],eax
			inc	ecx
			mov	esi,[esi]._next
			.break .if ecx>=16
		.endw
		assume	esi:nothing
		or	pcapfl,2
	.endif
	lea	eax,pluginName
	ret
InitPlugin	ENDP

SaveSettings	PROC
	invoke	SetFileAttributes,addr datafile,0
	invoke	DeleteFile,addr datafile
	invoke	CreateFile,addr datafile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		invoke	WriteFile,edi,addr pcapfl,16+(32*8)+(16*4)+3,addr bread,0
		call	CloseHandle
	.endif
	ret
SaveSettings	ENDP

UnloadPlugin	PROC
	initSeh	<offset pcap_seh>
	call	pcap_exit
pcap_seh:rstSeh
	ret
UnloadPlugin	ENDP

_about	db	'Albu Cristian, 2007',0
GetAboutText	PROC
	mov	eax,offset _about
	ret
GetAboutText	ENDP

GetConfig	PROC	hParent:DWORD
	invoke	DialogBoxParam,hInstance,1000,hParent,offset dlgConfig,0
	ret
GetConfig	ENDP

dlgConfig	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		.if (firewall&4)
			invoke	CheckDlgButton,hDlg,508,BST_CHECKED
		.else
			invoke	GetDlgItem,hDlg,113
			invoke	EnableWindow,eax,0
		.endif
		.if (firewall&8)
			invoke	CheckDlgButton,hDlg,509,BST_CHECKED
		.else
			invoke	GetDlgItem,hDlg,114
			invoke	EnableWindow,eax,0
		.endif
		.if firewall&16
			invoke	CheckDlgButton,hDlg,510,BST_CHECKED
		.endif
		.if firewall&32
			invoke	CheckDlgButton,hDlg,511,BST_CHECKED
		.endif
		.if firewall&64
			invoke	CheckDlgButton,hDlg,512,BST_CHECKED
		.endif
		.if firewall&128
			invoke	CheckDlgButton,hDlg,513,BST_CHECKED
		.endif
		movzx	eax,fsyn1
		invoke	SetDlgItemInt,hDlg,113,eax,0
		movzx	eax,fsyn2
		invoke	SetDlgItemInt,hDlg,114,eax,0
		movzx	eax,pcapsyn
		invoke	SetDlgItemInt,hDlg,110,eax,0
		movzx	eax,pcapudp
		invoke	SetDlgItemInt,hDlg,111,eax,0
		movzx	eax,pcapicmp
		invoke	SetDlgItemInt,hDlg,112,eax,0
		.if pcapfl&16
			invoke	CheckDlgButton,hDlg,501,BST_CHECKED
		.endif
		.if pcapfl&32
			invoke	CheckDlgButton,hDlg,502,BST_CHECKED
		.endif
		.if pcapfl&64
			invoke	CheckDlgButton,hDlg,503,BST_CHECKED
		.endif
		.if pcapfl&128
			invoke	CheckDlgButton,hDlg,504,BST_CHECKED
		.endif
		.if pcapfl&256
			invoke	CheckDlgButton,hDlg,505,BST_CHECKED
		.endif
		.if pcapfl&512
			invoke	CheckDlgButton,hDlg,506,BST_CHECKED
		.endif
		.if pcapfl&1024
			invoke	CheckDlgButton,hDlg,507,BST_CHECKED
		.endif
		.if pcapfl&16384
			invoke	CheckDlgButton,hDlg,514,BST_CHECKED
		.endif
		invoke	SendDlgItemMessage,hDlg,400,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_CHECKBOXES or LVS_EX_ONECLICKACTIVATE or LVS_EX_FULLROWSELECT,LVS_EX_CHECKBOXES or LVS_EX_ONECLICKACTIVATE or LVS_EX_FULLROWSELECT
		mov	lvcol.imask,LVCF_TEXT or LVCF_WIDTH
		mov	lvcol.fmt,LVCFMT_LEFT
		mov	lvcol.lx,150
		mov	lvcol.pszText,offset pcol1
		mov	lvcol.cchTextMax,sizeof pcol1
		mov	lvcol.iSubItem,0
		invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTCOLUMN,0,addr lvcol
		mov	lvcol.lx,100
		mov	lvcol.pszText,offset pcol2
		mov	lvcol.cchTextMax,sizeof pcol2
		mov	lvcol.iSubItem,1
		invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTCOLUMN,1,addr lvcol
		mov	lvcol.lx,183
		mov	lvcol.pszText,offset pcol3
		mov	lvcol.cchTextMax,sizeof pcol3
		mov	lvcol.iSubItem,2
		invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTCOLUMN,2,addr lvcol
		call	pcapex

		.if pcapfl&1
pcap_in:		.if (!(pcapfl&2))
				mov	pcaptimer,0
			.endif
			invoke	SendDlgItemMessage,hDlg,400,LVM_DELETEALLITEMS,0,0
			invoke	SetDlgItemInt,hDlg,100,pcaptimer,0
			mov	captate,0
			lea	edi,pcapadaptors
			mov	ecx,32
			xor	eax,eax
			cld
			rep	stosd
			invoke	GlobalAlloc,GPTR,65536
			mov	edi,eax
			push	eax
			mov	eax,offset pcapdevs._flags
			mov	dword ptr[eax],65536
			push	eax
			push	edi
			call	GetAdaptersInfo
			.if eax==ERROR_SUCCESS
				mov	esi,edi
				.while esi!=0
					lea	edi,[esi+8]
					push	esi
					mov	esi,pcapdevs._next
					assume	esi:ptr pcap_if_t
					xor	ecx,ecx
					assume	edx:nothing
					.while (esi!=0)
						mov	edx,[esi]._name
						mov	eax,dword ptr[edx]
						or	eax,20202020h
						.if eax=='acpr'
							.if ((byte ptr[edx+4]=='p')||(byte ptr[edx+4]=='P'))&&(word ptr[edx+5]=='/:')&&(byte ptr[edx+7]=='/')
								lea	edx,[edx+8]
							.endif
						.endif
						.if byte ptr[edx]=='\'
							inc	edx
						.endif
						mov	eax,[edx]
						or	eax,20202020h
						.if eax=='ived'
							mov	ax,[edx+4]
							or	ax,2020h
							.if ax=='ec'
								lea	edx,[edx+6]
							.endif
						.endif
						.if byte ptr[edx]=='\'
							inc	edx
						.endif
						mov	ax,[edx]
						or	ax,2020h
						.if ax=='pn'
							.if (byte ptr[edx+2]=='f')||(byte ptr[edx+2]=='F')
								lea	edx,[edx+3]
							.endif
							.if byte ptr[edx]=='_'
								inc	edx
							.endif
						.endif
						mov	esi,[esi]._next
						push	ecx
						xor	ecx,ecx
						.while (byte ptr[edi+ecx]!=0)&&(byte ptr[edi+ecx]!=32)
							mov	al,[edi+ecx]
							mov	ah,[edx+ecx]
							or	ax,2020h
							.break .if al!=ah
							inc	ecx
						.endw
						.if (al==ah)&&(byte ptr[edi+ecx]==0)&&(byte ptr[edx+ecx]==0)
							pop	ecx
							push	ecx
							mov	eax,[edi+256+4+128+4+4]
							mov	pcapmacs[ecx*8],eax
							mov	eax,[edi+256+4+128+4+4+4]
							mov	pcapmacs[ecx*8+4],eax
							push	ebx
							lea	ebx,[edi+256+4+128+4+4+4+4+4+4+4+4+4]
							push	ecx
							call	is_ip
							mov	eax,ecx
							pop	ecx
							mov	pcapips[ecx*4],eax
							pop	ebx
						.endif
						pop	ecx
						inc	ecx
						.break .if ecx>=16
					.endw
					assume	esi:nothing
					pop	esi
					mov	esi,[esi]
				.endw
			.endif
			call	GlobalFree
			mov	esi,pcapdevs._next
			assume	esi:ptr pcap_if_t
			xor	ecx,ecx
			.while esi!=0
				push	ecx
				mov	lvit.imask,LVIF_TEXT or LVIF_PARAM
				mov	lvit.lParam,ecx
				mov	lvit.iItem,ecx
				mov	lvit.iSubItem,0
				mov	lvit.state,0
				mov	lvit.stateMask,0
				mov	eax,[esi]._name
				.if eax
					mov	ecx,[eax]
					or	ecx,20202020h
					.if ecx=='acpr'
						.if ((byte ptr[eax+4]=='p')||(byte ptr[eax+4]=='P'))&&(word ptr[eax+5]=='/:')&&(byte ptr[eax+7]=='/')
							lea	eax,[eax+8]
						.endif
					.endif
					mov	lvit.pszText,eax
					mov	lvit.cchTextMax,256
					mov	lvit.iImage,0
					invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTITEM,0,addr lvit
					.if [esi]._descr!=0
						mov	eax,[esi]._descr
						mov	lvit.imask,LVIF_TEXT
						mov	lvit.iSubItem,2
						mov	lvit.pszText,eax
						mov	lvit.cchTextMax,256
						invoke	SendDlgItemMessage,hDlg,400,LVM_SETITEM,0,addr lvit
					.endif
					lea	edi,pcaperr
					pop	ecx
					push	ecx
					call	wmac
					mov	al,0
					stosb
					mov	eax,offset pcaperr
					mov	lvit.imask,LVIF_TEXT
					mov	lvit.iSubItem,1
					mov	lvit.pszText,eax
					mov	lvit.cchTextMax,256
					invoke	SendDlgItemMessage,hDlg,400,LVM_SETITEM,0,addr lvit
				.endif
				pop	ecx
				mov	eax,1
				.if ecx
					shl	eax,cl
				.endif
				.if (!(pcapfl&2))
					or	pcapadapt,ax
				.endif
				.if ax&pcapadapt
					push	ecx
					mov	lvit.iSubItem,0
					mov	lvit.stateMask,LVIS_STATEIMAGEMASK
					mov	lvit.state,8192
					mov	lvit.imask,LVIF_STATE
					invoke	SendDlgItemMessage,hDlg,400,LVM_SETITEMSTATE,ecx,addr lvit
					pop	ecx
				.endif
				mov	dword ptr pcapadaptors[ecx*8],0
				mov	dword ptr pcapadaptors[ecx*8+4],0
				push	ecx
				invoke	CreateThread,0,0,addr pcThread,ecx,0,addr thrid
				pop	ecx
				mov	dword ptr pcapadaptors[ecx*8+4],eax
				inc	ecx
				mov	esi,[esi]._next
				.break .if ecx>=16
			.endw
			assume	esi:nothing
			or	pcapfl,2
			invoke	GetDlgItem,hDlg,53
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,100
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,50
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,400
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,51
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,52
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,501
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,506
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,507
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,502
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,503
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,60
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,110
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,504
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,61
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,111
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,505
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,62
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,112
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,512
			invoke	EnableWindow,eax,1
			invoke	GetDlgItem,hDlg,513
			invoke	EnableWindow,eax,1
			invoke	CheckDlgButton,hDlg,500,BST_CHECKED
		.else
pcap_ex:		invoke	GetDlgItem,hDlg,53
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,100
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,50
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,400
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,51
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,52
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,501
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,506
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,507
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,502
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,503
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,60
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,110
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,504
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,61
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,111
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,505
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,62
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,112
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,512
			invoke	EnableWindow,eax,0
			invoke	GetDlgItem,hDlg,513
			invoke	EnableWindow,eax,0
		.endif
		invoke	SetTimer,hDlg,101,1000,0
	.elseif uMsg==WM_DESTROY
		invoke	KillTimer,hDlg,101
	.elseif uMsg==WM_TIMER
		invoke	SetDlgItemInt,hDlg,52,captate,0
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		mov	ebx,eax
		shr	ebx,16
		.if ax==2
			invoke	EndDialog,hDlg,0
		.elseif ax==500
			invoke	IsDlgButtonChecked,hDlg,500
			.if (eax==BST_CHECKED)&&(!(pcapfl&1))
				.if (!(pcapfl&4))
					call	pcap_init
				.endif
				.if pcapfl&4
					or	pcapfl,1
					jmp	pcap_in
				.else
					invoke	MessageBox,hDlg,addr pcapmsg,0,MB_OK
					and	pcapfl,1 xor -1
				;	call	pcap_exit
					call	pcapex
					invoke	CheckDlgButton,hDlg,500,BST_UNCHECKED
					jmp	pcap_ex
				.endif
			.elseif pcapfl&1
				and	pcapfl,1 xor -1
			;	call	pcap_exit
				call	pcapex
				jmp	pcap_ex
			.endif
		.elseif ax==501
			invoke	IsDlgButtonChecked,hDlg,501
			.if eax==BST_CHECKED
				or	pcapfl,16
			.else
				and	pcapfl,16 xor -1
			.endif
		.elseif ax==502
			invoke	IsDlgButtonChecked,hDlg,502
			.if eax==BST_CHECKED
				or	pcapfl,32
			.else
				and	pcapfl,32 xor -1
			.endif
		.elseif ax==503
			invoke	IsDlgButtonChecked,hDlg,503
			.if eax==BST_CHECKED
				or	pcapfl,64
			.else
				and	pcapfl,64 xor -1
			.endif
		.elseif ax==504
			invoke	IsDlgButtonChecked,hDlg,504
			.if eax==BST_CHECKED
				or	pcapfl,128
			.else
				and	pcapfl,128 xor -1
			.endif
		.elseif ax==505
			invoke	IsDlgButtonChecked,hDlg,505
			.if eax==BST_CHECKED
				or	pcapfl,256
			.else
				and	pcapfl,256 xor -1
			.endif
		.elseif ax==506
			invoke	IsDlgButtonChecked,hDlg,506
			.if eax==BST_CHECKED
				or	pcapfl,512
			.else
				and	pcapfl,512 xor -1
			.endif
		.elseif ax==507
			invoke	IsDlgButtonChecked,hDlg,507
			.if eax==BST_CHECKED
				or	pcapfl,1024
			.else
				.if hSysLog
					invoke	CloseHandle,hSysLog
					mov	hSysLog,0
				.endif
				and	pcapfl,1024 xor -1
			.endif
		.elseif ax==508
			invoke	IsDlgButtonChecked,hDlg,508
			.if eax==BST_CHECKED
				or	firewall,4
				invoke	GetDlgItem,hDlg,113
				invoke	EnableWindow,eax,1
			.else
				and	firewall,4 xor -1
				invoke	GetDlgItem,hDlg,113
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==509
			invoke	IsDlgButtonChecked,hDlg,509
			.if eax==BST_CHECKED
				or	firewall,8
				invoke	GetDlgItem,hDlg,114
				invoke	EnableWindow,eax,1
			.else
				and	firewall,8 xor -1
				invoke	GetDlgItem,hDlg,114
				invoke	EnableWindow,eax,0
			.endif
		.elseif ax==510
			invoke	IsDlgButtonChecked,hDlg,510
			.if eax==BST_CHECKED
				or	firewall,16
			.else
				and	firewall,16 xor -1
			.endif
		.elseif ax==511
			invoke	IsDlgButtonChecked,hDlg,511
			.if eax==BST_CHECKED
				or	firewall,32
			.else
				and	firewall,32 xor -1
			.endif
		.elseif ax==512
			invoke	IsDlgButtonChecked,hDlg,512
			.if eax==BST_CHECKED
				or	firewall,64
			.else
				and	firewall,64 xor -1
			.endif
		.elseif ax==513
			invoke	IsDlgButtonChecked,hDlg,513
			.if eax==BST_CHECKED
				or	firewall,128
			.else
				and	firewall,128 xor -1
			.endif
		.elseif ax==514
			invoke	IsDlgButtonChecked,hDlg,514
			.if eax==BST_CHECKED
				or	pcapfl,16384
			.else
				and	pcapfl,16384 xor -1
			.endif
		.elseif (ax==100)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,100,0,0
			mov	pcaptimer,eax
		.elseif (ax==110)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,110,0,0
			.if eax>255
				mov	al,255
			.endif
			mov	pcapsyn,al
		.elseif (ax==111)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,111,0,0
			.if eax>255
				mov	al,255
			.endif
			mov	pcapudp,al
		.elseif (ax==112)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,112,0,0
			.if eax>255
				mov	al,255
			.endif
			mov	pcapicmp,al
		.elseif (ax==113)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,113,0,0
			mov	fsyn1,ax
		.elseif (ax==114)&&(bx==EN_CHANGE)
			invoke	GetDlgItemInt,hDlg,114,0,0
			mov	fsyn2,ax
		.endif
	.elseif uMsg==WM_NOTIFY
		mov	ebx,lParam
		assume	ebx:ptr NMHDR
		mov	eax,[ebx].code
		assume	ebx:nothing
		.if eax==LVN_ITEMCHANGED
			assume	ebx:ptr NM_LISTVIEW
			.if ([ebx].uChanged&LVIF_STATE)&&([ebx].iItem!=-1)
				mov	eax,[ebx].uOldState
				xor	eax,[ebx].uNewState
				.if eax&8192
					mov	eax,[ebx].iItem
					mov	lvit.iItem,eax
					mov	lvit.iSubItem,0
					mov	lvit.lParam,-1
					mov	lvit.imask,LVIF_PARAM
					invoke	SendDlgItemMessage,hDlg,400,LVM_GETITEM,0,addr lvit
					.if eax
						mov	ecx,lvit.lParam
						.if ecx<16
							mov	edx,1
							.if ecx
								shl	edx,cl
							.endif
							.if [ebx].uNewState&8192
								.if (!(dx&pcapadapt))
									or	pcapadapt,dx
									push	ecx
									invoke	CreateThread,0,0,addr pcThread,ecx,0,addr thrid
									pop	ecx
									mov	dword ptr pcapadaptors[ecx*8+4],eax
								.endif
							.else
								.if dx&pcapadapt
									xor	edx,-1
									and	pcapadapt,dx
								.endif
							.endif
						.endif
					.endif
				.endif
			.endif
		.endif
		assume	ebx:nothing
	.endif
	xor	eax,eax
	ret
dlgConfig	ENDP

pcap_init:
	mov	hPcap,0
	mov	pchklast,0
	mov	pcap_freealldevs,0
	mov	pcapdevs._name,0
	mov	pcap_open_live,0
	mov	pcap_next_ex,0
	mov	pcap_close,0
	mov	hSysLog,0
	mov	pcap_findalldevs_ex,0
	invoke	LoadLibrary,addr wpcap
	.if eax
		mov	hPcap,eax
		invoke	GetProcAddress,hPcap,addr pcap_f2
		mov	pcap_freealldevs,eax
		invoke	GetProcAddress,hPcap,addr pcap_f3
		mov	pcap_open_live,eax
		invoke	GetProcAddress,hPcap,addr pcap_f4
		mov	pcap_next_ex,eax
		invoke	GetProcAddress,hPcap,addr pcap_f5
		mov	pcap_close,eax
		invoke	GetProcAddress,hPcap,addr pcap_f1
		mov	pcap_findalldevs_ex,eax
		.if (eax!=0)&&(pcapdevs._next==0)
			push	offset pcaperr
			push	offset pcapdevs
			push	0
			push	offset pcapstr
			call	dword ptr pcap_findalldevs_ex
			add	esp,4*4
		.endif
	.endif
	mov	GetAdaptersInfo,0
	mov	eax,hIphlp
	.if eax==0
		invoke	LoadLibrary,addr ipcap
		mov	hIphlp,eax
	.endif
	.if eax
		push	eax
		invoke	GetProcAddress,eax,addr ip_f1
		mov	GetAdaptersInfo,eax
		pop	eax
	.endif
	.if (hPcap==0)||(pcap_freealldevs==0)||(pcap_open_live==0)||(pcap_next_ex==0)||(pcap_close==0)||(pcap_findalldevs_ex==0)||(GetAdaptersInfo==0)
		and	pcapfl,-1 xor 5
	.else
		.if (!(pcapfl&8))
			or	pcapfl,1
		.endif
		or	pcapfl,4+8
	.endif
	ret


pcap_exit:
	.if hIphlp
		invoke	FreeLibrary,hIphlp
		mov	hIphlp,0
	.endif
	.if hSysLog
		invoke	CloseHandle,hSysLog
	.endif
	mov	ecx,16
	lea	esi,pcapadaptors
	.while ecx
		.if dword ptr[esi+4]!=0
			push	ecx
			push	dword ptr[esi]
			call	pcap_close
			add	esp,4
			invoke	TerminateThread,dword ptr[esi+4],0
			mov	dword ptr[esi+4],0
			pop	ecx
		.endif
		lea	esi,[esi+8]
		dec	ecx
	.endw
;	.if pcap_freealldevs
;		push	pcapdevs._next
;		call	pcap_freealldevs
;		add	esp,4
;		mov	pcapdevs._next,0
;	.endif
	.if hPcap
		invoke	FreeLibrary,hPcap
		mov	hPcap,0
	.endif
	ret

pcapex:
	mov	ecx,16
	lea	esi,pcapadaptors
	.while ecx
		.if dword ptr[esi+4]!=0
			push	ecx
			push	dword ptr[esi]
			call	pcap_close
			add	esp,4
			invoke	TerminateThread,dword ptr[esi+4],0
			mov	dword ptr[esi+4],0
			pop	ecx
		.endif
		lea	esi,[esi+8]
		dec	ecx
	.endw
	ret

pcap_initstr:
	assume	edx:ptr syn_str
	mov	[edx].syn_idx,0
	mov	[edx].isflood,0
	lea	edx,[edx].sinfo
	mov	ecx,20
	assume	edx:ptr syn_info
	.while ecx
		mov	[edx].isflood,0
		mov	[edx].lastip,0
		lea	edx,[edx+sizeof syn_info]
		dec	ecx
	.endw
	assume	edx:nothing
	ret


pfloodpar:
	assume	edx:ptr syn_str
	movzx	ecx,[edx].syn_idx
	inc	[edx].syn_idx
	.if [edx].syn_idx>=20
		mov	[edx].syn_idx,0
	.endif
	mov	eax,ecx
	shl	ecx,4
	lea	ecx,[ecx+eax*4]
	lea	edx,[edx].sinfo
	assume	edx:ptr syn_info
	invoke	GetTickCount
	mov	[edx+ecx].lastcount,eax
	mov	eax,[esi+1ah]
	mov	[edx+ecx].lastip,eax
	mov	eax,[esi+1eh]
	mov	[edx+ecx].lastdstip,eax
	movzx	eax,word ptr[esi+24h]
	mov	[edx+ecx].lastport,eax
	assume	edx:nothing
	ret

pscanchk:
	assume	edx:ptr syn_str
	push	edx
	lea	edx,[edx].sinfo
	assume	edx:ptr syn_info
	mov	ecx,20
	.while ecx
		mov	eax,[edx].lastip
		.if eax
		mov	ebx,[edx].lastcount
		push	ecx
		push	edx
		push	esi
		push	edi
		xor	esi,esi
		xor	edi,edi
		.while ecx
			.if ([edx].lastip==eax)
				.if ([edx].lastport!=edi)
					mov	edi,[edx].lastcount
					sub	edi,ebx
					.if edi>7fffffffh
						neg	edi
					.endif
					.if edi<3
						inc	esi
						.if esi>=4
							pop	edi
							pop	esi
							pop	edx
							pop	ecx
							pop	edx
							assume	edx:ptr syn_str
							mov	[edx].lastip,eax
							mov	[edx].isflood,2
							push	edx
							pop	edx
							.if pchklast==0
								mov	pchklast,edx
							.endif
							assume	edx:ptr syn_info
							ret
						.endif
					.endif
				.endif
				mov	edi,[edx].lastport
			.endif
			dec	ecx
			lea	edx,[edx+sizeof syn_info]
		.endw
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		.endif
		dec	ecx
		lea	edx,[edx+sizeof syn_info]
	.endw
	pop	edx
	assume	edx:nothing
	ret

pfloodchk:
	assume	edx:ptr syn_str
	push	eax
	push	edx
	lea	edx,[edx].sinfo
	assume	edx:ptr syn_info
	mov	ecx,20
	.while ecx
		mov	eax,[edx].lastip
		.if eax
			mov	ebx,[edx].lastcount
			push	ecx
			push	edx
			push	esi
			push	edi
			xor	esi,esi
			.while ecx
				.if ([edx].lastip==eax)
					mov	edi,[edx].lastcount
					sub	edi,ebx
					.if edi>7fffffffh
						neg	edi
					.endif
					.if edi<3
						inc	esi
						.if esi>=dword ptr[esp+16+4]
							pop	edi
							pop	esi
							pop	edx
							pop	ecx
							pop	edx
							assume	edx:ptr syn_str
							mov	[edx].lastip,eax
							mov	[edx].isflood,1
							push	edx
							pop	edx
							.if pchklast==0
								mov	pchklast,edx
							.endif
							pop	eax
							assume	edx:ptr syn_info
							ret
						.endif
					.endif
				.endif
				dec	ecx
				lea	edx,[edx+sizeof syn_info]
			.endw
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
		.endif
		dec	ecx
		lea	edx,[edx+sizeof syn_info]
	.endw
	pop	edx
	pop	eax
	ret

nscantest:
	assume	edx:ptr syn_str
	.if [edx].isflood!=1
		ret
	.endif
	push	eax
	push	edx
	mov	eax,[edx].lastip
	lea	edx,[edx].sinfo
	assume	edx:ptr syn_info
	mov	ecx,20
	.while ecx
		.break .if ([edx].lastip==eax)
		dec	ecx
		lea	edx,[edx+sizeof syn_info]
	.endw
	.if ecx
		mov	ebx,[edx].lastdstip
		.while ecx
			.if ([edx].lastip==eax)&&(ebx!=[edx].lastdstip)
				ret
			.endif
			dec	ecx
			lea	edx,[edx+sizeof syn_info]
		.endw
	.endif
	mov	[edx].isflood,0
	pop	edx
	pop	eax
	ret
	assume	edx:nothing


pcThread	PROC	lParam:DWORD
	local	temp1:dword
	local	temp2:dword
	local	mymac:qword
	local	mymactmp:qword
	local	gotmac:byte
	local	synflood:syn_str
	local	udpflood:syn_str
	local	icmpflood:syn_str
	local	finflood:syn_str
	mov	dword ptr mymac,0
	mov	dword ptr mymac+4,0
	mov	dword ptr mymactmp,0
	mov	dword ptr mymactmp+4,0
	lea	edx,synflood
	call	pcap_initstr
	lea	edx,udpflood
	call	pcap_initstr
	lea	edx,icmpflood
	call	pcap_initstr
	mov	gotmac,0
	mov	ecx,lParam
	.if dword ptr pcapadaptors[ecx*8]==0
		push	ecx
		mov	esi,pcapdevs._next
		assume	esi:ptr pcap_if_t
		.while (esi!=0)&&(ecx!=0)
			dec	ecx
			mov	esi,[esi]._next
		.endw
		push	offset pcaperr
		push	pcaptimer
		push	1
		push	65536
		mov	eax,[esi]._name
		mov	edx,[eax]
		or	edx,20202020h
		.if edx=='acpr'
			.if ((byte ptr[eax+4]=='p')||(byte ptr[eax+4]=='P'))&&(word ptr[eax+5]=='/:')&&(byte ptr[eax+7]=='/')
				lea	eax,[eax+8]
			.endif
		.endif
		push	eax
		call	pcap_open_live
		add	esp,5*4
		pop	ecx
		mov	pcapadaptors[ecx*8],eax
		assume	esi:nothing
	.endif
	.if (dword ptr pcapmacs[ecx*8]!=0)||(word ptr pcapmacs[ecx*8+4]!=0)
		mov	gotmac,1
	.endif
	.if dword ptr pcapadaptors[ecx*8]==0
		mov	dword ptr pcapadaptors[ecx*8+4],0
		invoke	ExitThread,0
	.endif
	.while 1
		mov	ecx,lParam
		mov	edx,1
		.if ecx
			shl	edx,cl
		.endif
		and	dx,pcapadapt
		.if dx!=0
			push	ecx
			lea	eax,temp1
			push	eax
			lea	eax,temp2
			push	eax
			push	dword ptr pcapadaptors[ecx*8]
			call	pcap_next_ex
			add	esp,3*4
			pop	ecx
			.if eax==1
				inc	captate
				mov	esi,temp1
				.if gotmac==0
					lea	ecx,mymac
					.if (dword ptr [ecx]==0)&&(dword ptr[ecx+4]==0)
						mov	eax,[esi]
						mov	dword ptr mymac,eax
						mov	eax,[esi+4]
						mov	word ptr mymac+4,ax
						mov	eax,[esi+6]
						mov	dword ptr mymactmp,eax
						mov	eax,[esi+4+6]
						mov	word ptr mymactmp+4,ax
					.else
						mov	eax,dword ptr mymac
						mov	edx,dword ptr mymac+4
						mov	ecx,lParam
						.if (eax==[esi])&&(dx==[esi+4])
							mov	eax,dword ptr mymactmp
							mov	edx,dword ptr mymactmp+4
							.if (eax!=[esi+6])&&(dx!=[esi+10])
								mov	gotmac,1
								mov	eax,dword ptr mymac
								mov	pcapmacs[ecx*8],eax
								mov	eax,dword ptr mymac+4
								mov	pcapmacs[ecx*8+4],eax
								jmp	hasmac
							.endif
						.elseif (eax==[esi+6])&&(dx==[esi+10])
							mov	eax,dword ptr mymactmp
							mov	edx,dword ptr mymactmp+4
							.if (eax!=[esi])&&(dx!=[esi+4])
								mov	eax,dword ptr mymac
								mov	pcapmacs[ecx*8],eax
								mov	eax,dword ptr mymac+4
								mov	pcapmacs[ecx*8+4],eax
								mov	gotmac,1
								jmp	hasmac
							.endif
						.else
							mov	eax,dword ptr mymactmp
							mov	edx,dword ptr mymactmp+4
							.if (eax==[esi])&&(dx==[esi+4])
								mov	eax,dword ptr mymac
								mov	edx,dword ptr mymac+4
								.if (eax!=[esi+6])&&(dx!=[esi+10])
									mov	eax,dword ptr mymactmp
									mov	pcapmacs[ecx*8],eax
									mov	eax,dword ptr mymactmp+4
									mov	pcapmacs[ecx*8+4],eax
									mov	gotmac,1
									jmp	hasmac
								.endif
							.elseif (eax==[esi+6])&&(dx==[esi+10])
								mov	eax,dword ptr mymac
								mov	edx,dword ptr mymac+4
								.if (eax!=[esi])&&(dx!=[esi+4])
									mov	eax,dword ptr mymactmp
									mov	pcapmacs[ecx*8],eax
									mov	eax,dword ptr mymactmp+4
									mov	pcapmacs[ecx*8+4],eax
									mov	gotmac,1
									jmp	hasmac
								.endif
							.else
								mov	eax,[esi]
								mov	dword ptr mymac,eax
								mov	eax,[esi+4]
								mov	word ptr mymac+4,ax
								mov	eax,[esi+6]
								mov	dword ptr mymactmp,eax
								mov	eax,[esi+4+6]
								mov	word ptr mymactmp+4,ax
							.endif
						.endif
					.endif
					mov	ecx,lParam
					mov	eax,pcapips[ecx*4]
					.if (eax==[esi+1eh])||(eax==0)
						jmp	_nmac
					.endif
				.else
hasmac:					.if pcapfl&16
						mov	edx,pcapmacs[ecx*8+4]
						mov	ecx,pcapmacs[ecx*8]
						mov	eax,[esi+26]
						mov	ebx,[esi+30]
						.if (ecx==[esi])&&(dx==[esi+4])
							xor	ebx,ebx
						.endif
						.if (ecx==[esi+6])&&(dx==[esi+4+6])
							xor	eax,eax
						.endif
					.endif
					assume	edi:nothing
_nmac:					mov	ecx,lParam
					.if (pcapfl&1536)&&(byte ptr[esi+17h]==11h)&&((word ptr[esi+1ah]==(168*256+192))||(word ptr[esi+1ah]==10))&&(word ptr[esi+24h]==202h)
						push	ecx
						.if pcapfl&1024
							call	wsyslog
						.endif
						.if pcapfl&512
							call	op_slog
						.endif
						pop	ecx
					.else
					mov	eax,pcapips[ecx*4]
					mov	edx,pcapmacs[ecx*8+4]
					mov	ecx,pcapmacs[ecx*8]
					.if ((ecx!=[esi+6])&&(dx!=[esi+4+6]))||(eax!=[esi+1ah])
						.if ((ecx==[esi])&&(dx==[esi+4]))||(eax==[esi+1eh])||(eax==0)
							mov	eax,[esi+1ah]
							assume	edx:ptr syn_str
							.if 1	;(ecx==[esi])&&(dx==[esi+4])
								.if (pcapfl&96)&&(byte ptr[esi+17h]==6)&&(byte ptr[esi+2fh]==2)
									.if (synflood.isflood==0)||(eax==synflood.lastip)	;tcp/syn
										lea	edx,synflood
										call	pfloodpar
										.if synflood.isflood==0
											.if pcapfl&32
												lea	edx,synflood
												call	pscanchk
											.endif
											.if pcapfl&64
												lea	edx,synflood
												movzx	eax,pcapsyn
												call	pfloodchk
												.if synflood.isflood==1
													mov	synflood.isflood,3
												.endif
											.endif
										.endif
									.endif
								.elseif (byte ptr[esi+17h]==11h)&&(udpflood.isflood==0)&&(pcapfl&128)	;udp
									.if (word ptr[esi+24h]!=(53*256))&&(word ptr[esi+22h]!=(53*256))
									.if (udpflood.isflood==0)||(eax==udpflood.lastip)	;tcp/syn
										lea	edx,udpflood
										call	pfloodpar
										.if udpflood.isflood==0
											lea	edx,udpflood
											movzx	eax,pcapudp
											call	pfloodchk
											.if udpflood.isflood==1
												mov	udpflood.isflood,4
											.endif
										.endif
									.endif
									.endif
								.elseif (byte ptr[esi+17h]==1)&&(icmpflood.isflood==0)&&(pcapfl&256)	;icmp
									.if (icmpflood.isflood==0)||(eax==icmpflood.lastip)	;tcp/syn
										lea	edx,icmpflood
										call	pfloodpar
										.if icmpflood.isflood==0
											lea	edx,icmpflood
											movzx	eax,pcapicmp
											call	pfloodchk
											.if icmpflood.isflood==1
												mov	icmpflood.isflood,5
											.endif
										.endif
									.endif
								.endif
							.elseif 0	;pcapfl&32
								.if (byte ptr[esi+17h]==6)&&(byte ptr[esi+2fh]==2)
									.if (synflood.isflood==0)||(eax==synflood.lastip)	;tcp/syn
										lea	edx,synflood
										call	pfloodpar
										.if synflood.isflood==0
											lea	edx,synflood
											call	pfloodchk
											lea	edx,synflood
											call	nscantest
											.if synflood.isflood==1
												mov	synflood.isflood,3+128
											.endif
										.endif
									.endif
								.elseif (byte ptr[esi+17h]==11h)&&(udpflood.isflood==0)		;udp
									.if (udpflood.isflood==0)||(eax==udpflood.lastip)	;tcp/syn
										lea	edx,udpflood
										call	pfloodpar
										.if udpflood.isflood==0
											lea	edx,udpflood
											movzx	eax,pcapudp
											call	pfloodchk
											lea	edx,udpflood
											call	nscantest
											.if udpflood.isflood==1
												mov	udpflood.isflood,4+128
											.endif
										.endif
									.endif
								.elseif (byte ptr[esi+17h]==1)&&(icmpflood.isflood==0)		;icmp
									.if (icmpflood.isflood==0)||(eax==icmpflood.lastip)
										lea	edx,icmpflood
										call	pfloodpar
										.if icmpflood.isflood==0
											lea	edx,icmpflood
											movzx	eax,pcapicmp
											call	pfloodchk
											lea	edx,icmpflood
											call	nscantest
											.if icmpflood.isflood==1
												mov	icmpflood.isflood,5+128
											.endif
										.endif
									.endif
								.endif
							.endif
						.endif
					.endif
					.endif
					assume	edx:nothing
				.endif
			.else
				invoke	Sleep,100
			.endif
			call	op_pcap
		.else
			.break
		.endif
	.endw
	push	ecx
	mov	ecx,lParam
	push	pcapadaptors[ecx*8]
	call	pcap_close
	add	esp,4
	pop	ecx
	mov	pcapadaptors[ecx*8],0
	mov	dword ptr pcapadaptors[ecx*8+4],0
	invoke	ExitThread,0
	ret
pcThread	ENDP


msg393	db	'Port scan detected from IP: ',0
msg394	db	'Last scanned ports: ',0
msg395	db	'SYN Flood detected from IP: ',0
msg396	db	'UDP Flood detected from IP: ',0
msg397	db	'ICMP Flood detected from IP: ',0
msg398	db	' port: ',0
msg399	db	'random',0
op_pcap:
	invoke	GetTickCount
	.if eax==lastsyslog
		ret
	.endif
	mov	lastsyslog,eax
	.if (!(firewall&128))
		push	edi
		mov	edx,pchklast
		call	pcap_initstr
		mov	pchklast,0
		pop	edi
		ret
	.endif
	push	edi
	mov	edi,offset opmsgs
	push	esi

	mov	edx,pchklast
	assume	edx:ptr syn_str
	.if [edx].isflood==2
		push	edx
		lea	edx,msg393
		call	copyedx
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		push	eax
		call	w_ip
		pop	eax
		mov	ax,' .'
		stosw
		lea	edx,msg394
		call	copyedx
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		lea	edx,[edx].sinfo
		mov	ecx,20
		xor	ebx,ebx
		.while ecx!=0
			assume	edx:ptr syn_info
			.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
				mov	ebx,[edx].lastport
				push	eax
				push	edx
				push	ecx
				mov	eax,ebx
				push	ebx
				xchg	al,ah
				call	itoa
				pop	ebx
				mov	ax,' ,'
				stosw
				pop	ecx
				pop	edx
				pop	eax
			.endif
			lea	edx,[edx+sizeof syn_info]
			dec	ecx
			assume	edx:ptr syn_str
		.endw
		.if word ptr[edi-2]==' ,'
			dec	edi
			dec	edi
		.endif
		pop	edx
	.elseif [edx].isflood<128
		push	edx
		.if [edx].isflood==3
			lea	edx,msg395
		.elseif [edx].isflood==4
			lea	edx,msg396
		.else
			lea	edx,msg397
		.endif
		call	copyedx
		pop	edx
		push	edx
		mov	eax,[edx].lastip
		push	eax
		call	w_ip
		pop	eax
		pop	edx
		push	edx
		.if ([edx].isflood!=5)
			lea	edx,msg398
			call	copyedx
			pop	edx
			push	edx
			mov	eax,[edx].lastip
			lea	edx,[edx].sinfo
			mov	ecx,20
			xor	ebx,ebx
			.while ecx!=0
				assume	edx:ptr syn_info
				.if (eax==[edx].lastip)&&(bx!=word ptr[edx].lastport)
					mov	bx,word ptr[edx].lastport
					add	ebx,10000h
				.endif
				lea	edx,[edx+sizeof syn_info]
				dec	ecx
				assume	edx:ptr syn_str
			.endw
			.if ebx>20000h
				lea	edx,msg399
				call	copyedx
				mov	ax,'[ '
				stosw
				pop	edx
				push	edx
				mov	eax,[edx].lastip
				lea	edx,[edx].sinfo
				mov	ecx,20
				.while ecx!=0
					xor	ebx,ebx
					assume	edx:ptr syn_info
					.if (eax==[edx].lastip)&&(ebx!=[edx].lastport)
						mov	ebx,[edx].lastport
						push	eax
						push	edx
						push	ecx
						mov	eax,ebx
						push	ebx
						xchg	al,ah
						call	itoa
						pop	ebx
						mov	ax,' ,'
						stosw
						pop	ecx
						pop	edx
						pop	eax
					.endif
					lea	edx,[edx+sizeof syn_info]
					dec	ecx
					assume	edx:ptr syn_str
				.endw
				.if word ptr[edi-2]==' ,'
					dec	edi
					dec	edi
				.endif
				mov	al,']'
				stosb
			.else
				movzx	eax,bx
				xchg	al,ah
				call	itoa
			.endif
		.endif
		pop	edx
	.endif
	mov	al,0
	stosb
	push	offset opmsgs
	call	SendNotificationMessage

	pop	esi
	mov	edx,pchklast
	call	pcap_initstr
	mov	pchklast,0
	pop	edi
	ret



slmsg	db	'SysLog[',0
slog	db	'SysLog.log',0
wsyslog:push	ebx
	.if hSysLog==0
		invoke	GetFileAttributes,addr slog
		.if eax==-1
			invoke	CreateFile,addr slog,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,CREATE_ALWAYS,0,0
			mov	hSysLog,eax
		.else
			invoke	CreateFile,addr slog,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,0,0
			mov	hSysLog,eax
			invoke	SetFilePointer,eax,0,0,FILE_END
		.endif
	.endif
	push	esi
	push	edi
	lea	edi,slogdata
	mov	eax,5b0a0dh
	stosd
	dec	edi
	invoke	GetLocalTime,addr systime
	movzx	eax,systime.wYear
	call	w4
	mov	al,'-'
	stosb
	movzx	eax,systime.wMonth
	call	w2
	mov	al,'-'
	stosb
	movzx	eax,systime.wDay
	call	w2
	mov	al,' '
	stosb
	movzx	eax,systime.wHour
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wMinute
	call	w2
	mov	al,':'
	stosb
	movzx	eax,systime.wSecond
	call	w2
	mov	ax,' ]'
	stosw
	movzx	ecx,word ptr[esi+26h]
	xchg	cl,ch
	sub	ecx,8
	lea	esi,[esi+2ah]
	.if ecx>500
		mov	ecx,500
		rep	movsb
		mov	eax,'... '
		stosd
	.else
		rep	movsb
	.endif
	mov	ecx,edi
	sub	ecx,offset slogdata
	invoke	WriteFile,hSysLog,addr slogdata,ecx,addr bread,0
	pop	edi
	pop	esi
	pop	ebx
	ret

op_slog:
	invoke	GetTickCount
	.if eax==lastsyslog
		ret
	.endif
	mov	lastsyslog,eax
	push	ebx
	assume	esi:ptr usrstruc
	push	edi
	mov	edi,offset opmsgs
	push	esi
	mov	ebx,esi

	lea	edx,slmsg
	call	copyedx
	mov	eax,[ebx+1ah]
	push	ebx
	call	w_ip
	pop	ebx
	mov	eax,' :]'
	stosd
	dec	edi
	movzx	ecx,word ptr[ebx+26h]
	xchg	cl,ch
	sub	ecx,8
	push	ecx
	.if ecx>512
		mov	ecx,512
	.endif
	lea	ebx,[ebx+2ah]
	.while ecx
		mov	al,[ebx]
		.if al=='|'
			mov	al,'/'
		.endif
		stosb
		inc	ebx
		dec	ecx
	.endw
	pop	ecx
	.if ecx>512
		mov	eax,'... '
		stosd
	.endif
	mov	al,0
	stosb
	push	offset opmsgs
	call	SendNotificationMessage
	pop	esi
	pop	edi
	pop	ebx
	ret

wmac:	push	ebx
	lea	ebx,pcapmacs[ecx*8]
	push	ecx
	mov	ecx,6
	.while ecx
		mov	al,[ebx]
		mov	ah,al
		and	ax,0ff0h
		shr	al,4
		or	ax,3030h
		.if al>'9'
			add	al,7
		.endif
		.if ah>'9'
			add	ah,7
		.endif
		stosw
		inc	ebx
		dec	ecx
		.if ecx
			mov	al,':'
			stosb
		.endif
	.endw
	pop	ecx
	pop	ebx
	ret

_wmac:	push	ecx
	mov	ecx,6
	.while ecx
		mov	al,[ebx]
		mov	ah,al
		and	ax,0ff0h
		shr	al,4
		or	ax,3030h
		.if al>'9'
			add	al,7
		.endif
		.if ah>'9'
			add	ah,7
		.endif
		stosw
		inc	ebx
		dec	ecx
		.if ecx
			mov	al,':'
			stosb
		.endif
	.endw
	pop	ecx
	ret


End DllEntry
