;	PCap version 1.00 Copyright (C) 2007 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.

;	To compile download masm32 from http://www.masm32.com and install it on the root directory of one of your hard drives
;	Copy source files to the partition where is masm32 installed and run \masm32\bin\blddll PCap
;	For more information send and e-mail to cristian.albu@gmail.com


pl_procs	macro

w2:	.if al>9
		mov	cl,10
		mov	ah,0
		div	cl
		or	ax,3030h
		stosw
	.else
		mov	byte ptr[edi],30h
		inc	edi
		or	al,30h
		stosb
	.endif
	ret
w4:	.if ax>=1000
		xor	dx,dx
		mov	cx,1000
		div	cx
		or	al,30h
		stosb
		mov	ax,dx
	.else
		mov	byte ptr[edi],30h
		inc	edi
	.endif
	.if al>=100
		mov	cl,100
		mov	ah,0
		div	cl
		or	al,30h
		stosb
		mov	al,ah
	.else
		mov	byte ptr[edi],30h
		inc	edi
	.endif
	jmp	w2

itoa:	mov	ebx,10
	xor	edx,edx
	div	ebx
	or	eax,eax
	jz	_d1
	push	edx
	call	itoa
	pop	edx
_d1:	or	dl,30h
	mov	al,dl
	stosb
	ret

w_ip:
	push	ebx
	push	ecx
	push	edx
		push	eax
		movzx	eax,al
		call	itoa
		mov	al,'.'
		stosb
		pop	eax
		push	eax
		shr	eax,8
		movzx	eax,al
		call	itoa
		mov	al,'.'
		stosb
		pop	eax
		push	eax
		shr	eax,16
		movzx	eax,al
		call	itoa
		mov	al,'.'
		stosb
		pop	eax
		push	eax
		shr	eax,24
		movzx	eax,al
		call	itoa
		pop	eax
	pop	edx
	pop	ecx
	pop	ebx
	ret

copyedx:
	.while (byte ptr[edx]!=0)
		mov	al,[edx]
		stosb
		inc	edx
	.endw
	ret

;edx=offset string,edi=hFile
copystr:
	xor	ecx,ecx
	inc	edi
	inc	edi
	push	edi
	.while byte ptr[edx+ecx]
		mov	al,[edx+ecx]
		stosb
		inc	ecx
	.endw
	pop	edi
	movzx	ecx,cx
	mov	[edi-2],cx
	lea	edi,[edi+ecx]
	ret

copystr1:
	movzx	ecx,word ptr[edx]
	push	esi
	lea	esi,[edx+2]
	rep	movsb
	mov	al,0
	stosb
	mov	edx,esi
	pop	esi
	ret

atoi:	xor	eax,eax
	xor	ebx,ebx
	push	edx
getdec0:mov	bl,[esi]
	inc	esi
	sub	bl,'0'
	cmp	bl,10
	jnc	_getdec
	push	ebx
	xor	edx,edx
	mov	bl,10
	mul	ebx
	pop	ebx
	add	eax,ebx
	jmp	getdec0
_getdec:pop	edx
	ret

is_ip:
	push	ebx
	push	esi
	xor	eax,eax
	xor	ecx,ecx
	mov	esi,ebx
	.if (byte ptr[esi]<'0')||(byte ptr[esi]>'9')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	call	atoi
	.if eax>255
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	mov	cl,al
	dec	esi
	.if (byte ptr[esi]!='.')&&(byte ptr[esi]!=' ')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	inc	esi
	.if (byte ptr[esi]<'0')||(byte ptr[esi]>'9')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	call	atoi
	.if eax>255
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	mov	ch,al
	dec	esi
	.if (byte ptr[esi]!='.')&&(byte ptr[esi]!=' ')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	inc	esi
	.if (byte ptr[esi]<'0')||(byte ptr[esi]>'9')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	call	atoi
	.if eax>255
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	shl	eax,16
	or	ecx,eax
	dec	esi
	.if (byte ptr[esi]!='.')&&(byte ptr[esi]!=' ')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	inc	esi
	.if (byte ptr[esi]<'0')||(byte ptr[esi]>'9')
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	call	atoi
	.if eax>255
		pop	esi
		pop	ebx
		xor	eax,eax
		ret
	.endif
	shl	eax,16+8
	or	ecx,eax
	xor	eax,eax
	inc	eax
	pop	esi
	pop	ebx
	ret

getdatafile:
	invoke	GetModuleFileName,hInstance,addr datafile,8192
	mov	esi,offset datafile
	mov	edi,esi
	.if byte ptr[esi]=='"'
		inc	esi
	.endif
	xor	ebx,ebx
	xor	edx,edx
	.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='"')
		.if byte ptr[esi]=='\'
			mov	ebx,esi
		.elseif byte ptr[esi]=='.'
			mov	edx,esi
		.endif
		movsb
	.endw
	.if edx>ebx
		mov	edi,edx
	.endif
	mov	eax,'tad.'
	stosd
	mov	al,0
	stosb
	ret
endm

formatmsg	macro
	.if al==0
		mov	eax,':oT$'
		stosd
		mov	al,' '
		stosb
		push	edi
		push	userId
		call	NickFromId
		.while byte ptr[edi]!=0
			inc	edi
		.endw
		mov	eax,'orF '
		stosd
		mov	eax,' :m'
		stosd
		dec	edi
		push	edi
		push	0
		call	NickFromId
		.while byte ptr[edi]!=0
			inc	edi
		.endw
		mov	eax,'<$ '
		stosd
		dec	edi
		push	edi
		push	0
		call	NickFromId
		.while byte ptr[edi]!=0
			inc	edi
		.endw
		mov	ax,' >'
		stosw
	.else
		mov	eax,' ***'
		stosd
	.endif
endm
